/**
 * Import dependencies
 */
'use strict';

var _toConsumableArray = require('babel-runtime/helpers/to-consumable-array')['default'];

var _Object$keys = require('babel-runtime/core-js/object/keys')['default'];

var _interopRequireDefault = require('babel-runtime/helpers/interop-require-default')['default'];

Object.defineProperty(exports, '__esModule', {
  value: true
});
exports['default'] = getBaseOptions;

var _sequelizeLibHooks = require('sequelize/lib/hooks');

var _sequelizeLibHooks2 = _interopRequireDefault(_sequelizeLibHooks);

var _arrayifyCompact = require('arrayify-compact');

var _arrayifyCompact2 = _interopRequireDefault(_arrayifyCompact);

/**
 * Define constants
 */
var hookNames = [].concat(_toConsumableArray(_Object$keys(_sequelizeLibHooks2['default'].hooks)), _toConsumableArray(_Object$keys(_sequelizeLibHooks2['default'].hookAliases)));

/**
 * Export base options getter
 */

function getBaseOptions(Class) {
  // Define options
  var options = {
    hooks: {},
    classMethods: {},
    instanceMethods: {}
  };

  // Iterate over static properties
  for (var propertyName in Class) {
    // Convert matching hook name into hook options
    if (hookNames.indexOf(propertyName) !== -1) {
      options.hooks[propertyName] = (0, _arrayifyCompact2['default'])([options.hooks[propertyName], Class[propertyName]]);
    }
    // Convert function into class method options
    else if (typeof Class[propertyName] === 'function') {
      options.classMethods[propertyName] = Class[propertyName];
    }
  }

  // Iterate over prototype properties
  for (var propertyName in Class.prototype) {
    // Convert function into instance method options
    if (typeof Class.prototype[propertyName] === 'function') {
      options.instanceMethods[propertyName] = Class.prototype[propertyName];
    }
  }

  // Return options
  return options;
}

module.exports = exports['default'];