/**
 * Export Faker options getter
 */
'use strict';

var _extends = require('babel-runtime/helpers/extends')['default'];

var _defineProperty = require('babel-runtime/helpers/define-property')['default'];

var _Object$keys = require('babel-runtime/core-js/object/keys')['default'];

Object.defineProperty(exports, '__esModule', {
  value: true
});
exports['default'] = getFakerOptions;

function getFakerOptions() {
  // Define options
  var options = {
    classMethods: {}
  };

  // Add Faker getter
  options.classMethods.getFakeAttributes = function (times) {
    var _this2 = this;

    function generate() {
      var _this = this;

      return _Object$keys(this.rawAttributes).filter(function (key) {
        return typeof _this.rawAttributes[key].faker === 'function';
      }).reduce(function (map, key) {
        return _extends({}, map, _defineProperty({}, key, _this.rawAttributes[key].faker()));
      }, {});
    }

    // Repeat
    if (times) {
      return Array.apply(null, new Array(times)).map(function () {
        return generate.call(_this2);
      });
    }
    return generate.call(this);
  };

  // Return options
  return options;
}

module.exports = exports['default'];