/**
 * Import dependencies
 */
'use strict';

var _extends = require('babel-runtime/helpers/extends')['default'];

var _defineProperty = require('babel-runtime/helpers/define-property')['default'];

var _Object$keys = require('babel-runtime/core-js/object/keys')['default'];

var _interopRequireDefault = require('babel-runtime/helpers/interop-require-default')['default'];

Object.defineProperty(exports, '__esModule', {
  value: true
});
exports['default'] = getJoiOptions;

var _joi = require('joi');

var _joi2 = _interopRequireDefault(_joi);

/**
 * Define constants
 */
var joiOptions = {
  convert: true,
  abortEarly: false,
  allowUnknown: true,
  skipFunctions: true,
  stripUnknown: false,
  presence: 'optional',
  context: {},
  language: {}
};

/**
 * Export Joi options getter
 */

function getJoiOptions() {
  // Define options
  var options = {
    classMethods: {},
    hooks: {}
  };

  // Add Joi schema getter
  options.classMethods.getJoiSchema = function () {
    var _this = this;

    return _Object$keys(this.rawAttributes).filter(function (key) {
      return (_this.rawAttributes[key].joi || {}).isJoi;
    }).reduce(function (map, key) {
      return _extends({}, map, _defineProperty({}, key, _this.rawAttributes[key].joi));
    }, {});
  };

  // Add validator hook
  options.hooks.beforeValidate = [function (model, config, callback) {
    _joi2['default'].validate(model.get(), model.Model.getJoiSchema(), joiOptions, function (error, values) {
      if (error) {
        throw error;
      }

      model.set(values, { reset: true });
      return callback();
    });
  }];

  // Return options
  return options;
}

module.exports = exports['default'];