/**
 * Define blacklist properties
 */
'use strict';

var _Object$getOwnPropertyNames = require('babel-runtime/core-js/object/get-own-property-names')['default'];

var _Object$defineProperty = require('babel-runtime/core-js/object/define-property')['default'];

Object.defineProperty(exports, '__esModule', {
  value: true
});
exports['default'] = ensurePropsEnumerability;
var blacklist = {
  staticProps: ['length', 'name', 'arguments', 'caller', 'prototype'],
  prototypeProps: ['constructor']
};

/**
 * Export properties enumerability enforcer utility
 */

function ensurePropsEnumerability(Class) {
  // Static properties
  _Object$getOwnPropertyNames(Class).filter(function (propName) {
    return blacklist.staticProps.indexOf(propName) === -1;
  }).forEach(function (propName) {
    return _Object$defineProperty(Class, propName, { enumerable: true });
  });

  // Prototype proerties
  _Object$getOwnPropertyNames(Class.prototype).filter(function (propName) {
    return blacklist.prototypeProps.indexOf(propName) === -1;
  }).forEach(function (propName) {
    return _Object$defineProperty(Class.prototype, propName, { enumerable: true });
  });
}

module.exports = exports['default'];